/*
 * COPYRIGHT (c) International Business Machines Corp. 2022
 *
 * This program is provided under the terms of the Common Public License,
 * version 1.0 (CPL-1.0). Any use, reproduction or distribution for this
 * software constitutes recipient's acceptance of CPL-1.0 terms which can be
 * found in the file LICENSE file or at
 * https://opensource.org/licenses/cpl1.0.php
 */
/* AUTO-GENERATED on Wed Nov  9 05:07:49 2022.  DO NOT EDIT! */

#include <string.h>
#include <pkcs11types.h>
#include "mechtable.h"
#include "mechtable.inc"

static const unsigned char numericalphabet[] = {
  0, 1, 2, 3, 4, 5, 6, 7,
  0, 8, 9, 10, 11, 12, 13, 0,
  14, 15, 16, 0, 0, 0, 0, 0,
  0, 0, 0, 17, 18, 0, 19, 20,
  21, 22, 23, 24, 0, 25, 26, 27,
  28, 0, 0, 0, 0, 0, 0, 0,
  29, 30, 31, 32, 33, 34, 35, 36,
  37, 0, 0, 0, 0, 0, 0, 0,
  38, 39, 40, 41, 42, 43, 44, 45,
  46, 47, 48, 0, 49, 50, 51, 0,
  52, 53, 54, 55, 0, 56, 57, 58,
  0, 0, 0, 0, 0, 0, 0, 0,
  59, 60, 61, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  62, 63, 64, 0, 0, 0, 65, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  66, 67, 68, 69, 70, 71, 72, 73,
  0, 74, 75, 0, 0, 0, 0, 0,
  0, 0, 76, 77, 78, 79, 80, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  81, 0, 0, 0, 0, 0, 0, 0,
  82, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
};
static const short numerictable[] = {
  -70, -69, 146, -73, 3, -67, -80, -47,
  -71, -75, -74, -82, -72, -81, -35, -34,
  -37, 30, 4, -36, -33, -32, -31, 24,
  27, -64, -65, -66, -48, 2, 108, 0,
  -76, -77, -78, 0, 0, 0, -93, -99,
  -111, -94, -100, -112, -87, -88, -102, -103,
  -104, -105, -106, -107, -45, -39, -40, -41,
  -42, -43, -44, 0, 0, 0, 0, -89,
  -90, -91, -38, -83, -84, -85, -95, -96,
  -97, -101, -108, -109, 0, 0, 0, 0,
  -11, -9, -1, -12, -13, -2, -8, -10,
  -7, -6, -29, -28, -24, 0, -25, 16,
  0, 0, -15, -21, -20, -16, -22, -23,
  -17, -19, -18, 0, 0, -56, -58, -60,
  -62, 0, 0, -49, -14, -4, -5, -3,
  -119, -30, 0, -26, -27, -52, -54, -53,
  -55, -46, 0, 0, -50, -57, -59, -61,
  -63, 0, -51, -116, -114, -113, -118, -115,
  -117, 0, 0, 69, 11, 77, 0, 0,
  0, -79, -92, -98, -110, -86, -68, -120,
  14, 0, 0, 0, 0, 0, 0, 19,
  112, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0,
};
int mechtable_idx_from_numeric(CK_ULONG mech)
{
    unsigned int idx1, idx2, idx3, idx4;
    int o1, o2, o3;
    int midx;

    idx1 = numericalphabet[(mech & 0xff000000u) >> 24u];
    idx2 = numericalphabet[(mech & 0x00ff0000u) >> 16u];
    idx3 = numericalphabet[(mech & 0x0000ff00u) >> 8u];
    idx4 = numericalphabet[mech & 0x000000ffu];
    o1 = numerictable[29 + idx1];
    if (o1 < 0) return -1;
    o2 = numerictable[o1 + idx2];
    if (o2 < 0) return -1;
    o3 = numerictable[o2 + idx3];
    if (o3 < 0) return -1;
    midx = numerictable[o3 + idx4];
    midx = -(midx + 1);
    if (0 <= midx && midx < 120 && mechtable_rows[midx].numeric == mech)
        return midx;
    return -1;
}

const struct mechrow *mechrow_from_numeric(CK_ULONG mech)
{
    int idx = mechtable_idx_from_numeric(mech);

    if (idx < 0)
        return NULL;
    return &mechtable_rows[idx];
}

static const unsigned char stringalphabet[] = {
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  1, 2, 3, 4, 5, 6, 7, 0,
  8, 9, 0, 0, 0, 0, 0, 0,
  0, 10, 11, 12, 13, 14, 15, 16,
  17, 18, 0, 19, 20, 21, 22, 23,
  24, 0, 25, 26, 27, 28, 29, 30,
  31, 32, 0, 0, 0, 0, 0, 33,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0,
};
static const short stringtable[] = {
  0, 0, 195, 45, 261, -34, 283, 161,
  28, 191, 9, 200, 132, 3, 161, 140,
  -46, 114, 169, 149, 128, 192, 136, 37,
  313, 185, 48, -118, 34, 162, -9, 190,
  -10, 220, 190, 306, 85, 126, 76, -14,
  -47, -48, -49, -50, 41, 116, -15, 109,
  235, 119, 281, 248, -110, 90, 188, 121,
  170, 1, 280, -20, 4, -8, -28, 94,
  -21, 211, 139, -29, -40, 176, -43, -30,
  -44, 220, 295, -86, 48, 235, 250, -92,
  -98, 220, -113, 195, 309, 235, 250, -116,
  283, -117, 100, 288, -3, -31, 79, -35,
  -38, -4, -5, -32, -36, -39, -37, -51,
  -33, 164, -64, 186, -69, 184, -76, 216,
  -70, -79, -45, -67, -71, -72, -82, 204,
  -83, -89, -95, 155, -101, -102, -105, 16,
  129, -1, 90, 120, 135, -73, 149, -6,
  125, 138, -12, 90, 43, 93, 45, 206,
  145, -16, 135, 148, -18, 138, 151, -22,
  156, 56, 60, 61, -24, 33, 272, 279,
  156, 141, -2, -26, -27, 147, 155, 143,
  -7, 137, 80, -13, 5, 81, 101, 159,
  167, 66, -17, -41, 162, -19, -42, 152,
  -23, 30, 185, 182, -52, -25, -53, -54,
  3, -55, 5, 196, -56, 198, -58, 195,
  201, -60, 200, 204, -62, 200, 106, 198,
  197, 210, -65, 202, 180, 59, 203, 190,
  108, 214, 217, 220, -74, 0, 110, 203,
  215, 214, 227, -77, 94, -57, 222, -59,
  200, 87, -61, 224, 212, -63, 239, -80,
  120, 232, 232, -66, 245, -84, 237, 215,
  225, 231, 239, 226, 254, -75, -87, 121,
  247, 246, 259, -90, -78, 252, 230, 240,
  246, 254, 241, 268, -93, 265, 122, 263,
  -81, 262, 275, -96, 267, 246, -85, 256,
  262, 270, 257, 284, -99, 283, 124, -88,
  125, 269, 281, 281, -91, 294, -103, 126,
  276, 288, 287, 300, -106, -94, 293, 292,
  305, -108, 297, 276, -97, 286, 292, 300,
  287, 314, -111, 312, 285, -100, 63, -114,
  289, 290, -115, 309, -68, -11, 0, -104,
  0, 0, 0, 0, -120, -107, 0, 0,
  0, 0, -109, -119, 0, 0, 0, 0,
  0, 0, 0, -112,
};
static const size_t commonprefixlength = 4;

int mechtable_idx_from_string(const char *mech)
{
    static const struct {
        const char *string;
        const char *alias;
    } aliaslist[] = {
        { "CKM_ECDSA_KEY_PAIR_GEN", "CKM_EC_KEY_PAIR_GEN" },
        { "CKM_IBM_EC_C25519", "CKM_IBM_EC_X25519" },
        { "CKM_IBM_EC_C448", "CKM_IBM_EC_X448" },
        { "CKM_IBM_EDDSA_SHA512", "CKM_IBM_ED25519_SHA512" },
    };
    size_t len = strlen(mech), i;
    short idx = 0;
    unsigned char h;

    for (i = commonprefixlength; i <= len; ++i) {
        h = stringalphabet[(int)mech[i]];
        idx = stringtable[idx + h];
        if (idx < 0) {
            idx = -(idx + 1);
            if (strcmp(mech, mechtable_rows[idx].string) == 0)
                return idx;
            goto outcheckaliases;
        }
    }
  outcheckaliases:
    for (i = 0; i < sizeof(aliaslist) / sizeof(aliaslist[0]); ++i) {
        if (strcmp(aliaslist[i].string, mech) == 0)
            return mechtable_idx_from_string(aliaslist[i].alias);
    }
    return -1;
}

const struct mechrow *mechrow_from_string(const char *mech)
{
    int idx = mechtable_idx_from_string(mech);

    if (idx < 0)
        return NULL;
    return &mechtable_rows[idx];
}

const struct mechtable_funcs mechtable_funcs = {
    .p_idx_from_num = &mechtable_idx_from_numeric,
    .p_idx_from_str = &mechtable_idx_from_string,
    .p_row_from_num = &mechrow_from_numeric,
    .p_row_from_str = &mechrow_from_string
};

